#include <stdio.h>
#include <avr/sleep.h>
#include "lcd_lib.h"
#include <avr/pgmspace.h>
#include <stdlib.h>            
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>


volatile int count;
volatile long int maintime;
volatile int sig = 1;

//timer interrupts every 2 ms
ISR (TIMER0_COMPA_vect) { 
	count++;
	if (count == 4)	
		count = 0;
}



void initialize(void)
{
	DDRA = 0xff;
	PORTA = 0x00;

	//set up timer 0 for timebase 
	TIMSK0= (1<<OCIE0A);	//turn on timer 0 cmp match ISR 
	OCR0A = 31;  	
	TCCR0B= 5; //0b00001011;	
	// turn on clear-on-match
	TCCR0A= (1<<WGM01) ;


	sei();
}





int main(){
	initialize();
	count = 0;

	while(1){	
	// for the switch to turn on and off the signal
		if ((PIND & 0x01) == 0){//switch is low,
			PORTA = 0; 
			}		
			else{//Switch high, 4 90 degree shifted square wave generated 
				if (count == 0){
					PORTA = 9;
					}
				else if (count == 1){
					PORTA = 10;
					}
				else if (count == 2){
					PORTA = 6;
					}
				else if (count == 3){
					PORTA = 5;
					}
		}
	}
	return 1;
}

